<?php
/*
function tr_view_home() {

    $payload = _trx.push ({
        'event'=> 'viewHome',
    });

}
*/
function tr_view_item() {
 
    $product_format_full = get_option('tr_product_format_full');
   
    global $product; 
    $product_id = $product->get_id();
    $price = $product->get_price();
    $name = $product->get_name();
    $category_id = $product->get_category_ids()[0];
    $category = get_term_by( 'id', $category_id, 'product_cat');
    $category_ids = $product->get_category_ids();
    if($product_format_full) {
        $payload = array(
            'event' => 'viewItem',
            'item' => array(
                'id' => $product_id,
                'price' => $price,
                'name' => $name,
                'categoryName' => $category->name,
            ),
        );
    } else {
        $payload = array(
            'event' => 'viewItem',
            'itemID' =>  $product_id
        );
    }
    $snippet = "<script> _trx.push(" . json_encode($payload) . ")</script>";
    print $snippet;
}

function tr_view_list_init() {

    global $TR_PRODUCTS;
}

function tr_view_list_item() {
    $product_format_full = get_option('tr_product_format_full');
    global $product, $TR_PRODUCTS;

    if($product_format_full) {
        $category_id = $product->get_category_ids()[0];
        $category = get_term_by( 'id', $category_id, 'product_cat');

        $TR_PRODUCTS[] = array(
        'id' => $product->get_id(),
        'name' => $product->get_name(),
        'price' => $product->get_price(),
        'categoryName' => $category->name
        );
    } else {
        $TR_PRODUCTS[] = array(
            'id' => $product->get_id(),
        );
    }
    $TR_PRODUCTS = array_slice($TR_PRODUCTS,0,4); //prende i primi 4 prodotti visualizzati
}

function tr_view_list_close() {

    global $TR_PRODUCTS;
   
    $payload = array(
        'event' => 'viewList',
        'items' => $TR_PRODUCTS
    );
       
    $snippet = "<script> _trx.push(" . json_encode($payload) . ")</script>";
    print $snippet;
}

function tr_view_basket() {

    $cart_contents = WC()->cart->get_cart_contents();

   foreach($cart_contents as $cart_content) {
        $category_id = $cart_content['data']->get_category_ids()[0];
        $category = get_term_by( 'id', $category_id, 'product_cat');

        $payload_cart_contents[] = array(  
            'id'=>  $cart_content['product_id'],
            'price'=> $cart_content['data']->get_price() ,
            'quantity'=> $cart_content['quantity'],
            'name' =>  $cart_content['data']->get_title(),
            'categoryName' =>  $category->name,
        );
    }
   $payload = array(
       'event' => 'viewBasket',
       'items' => $payload_cart_contents,
   );
    $snippet = "<script> _trx.push(" . json_encode($payload) . ")</script>";
    print $snippet;
}

function tr_track_transaction($order_id) {

    $order = new WC_Order($order_id);
    $_trx_optin = get_user_meta($order->get_user()->ID, '_trx_optin', esc_attr($_POST['_trx_optin']));

    if (array_key_exists(0, $_trx_optin)) $optin = boolval($_trx_optin[0]);
    else $optin = false;

    $order_number = $order->get_order_number();
    $subtotal = $order->get_subtotal();
    $shipping = $order->get_total_shipping();
    $discount = $order->get_total_discount();
    $total = $order->get_total();
    $coupons = $order->get_used_coupons(); //return coupon codes
    $currency = $order-> get_order_currency();
    $items  = $order->get_items(); //return array 
    $address  = $order->get_billing_address_1();
    $address2 = $order->get_billing_address_2();
    $city = $order->get_billing_city();
    $country = $order->get_billing_country(); //return string
    $phone = $order->get_billing_phone();
    $first_name = $order->get_billing_first_name();
    $last_name = $order->get_billing_last_name();
    $company = $order->get_billing_company();
    $email = $order->get_billing_email();
    $zip_code = $order->get_shipping_postcode();
    if (!$zip_code) $zip_code = $order->get_billing_postcode();
    
    $payload_items = array();
    
    foreach($items as $item) {
        $payload_items[] = array (  
            'id'=>  $item->get_product_id(),
            'price'=> $item->get_total(),
            'quantity'=> $item->get_quantity(),
        );
    }

    $payload = array(
        'event' => 'trackTransaction',
        'transaction'=> array(
            'id'=> $order_number, 
            'subtotal'=> $subtotal,
            'shipping'=> $shipping,
            'discount'=>$discount,
            'total'=> $total,
            'coupon'=> $coupons, 
            'currency'=> $currency,
        ),
        'items'=> $payload_items,
        'address'=> array(
            'address'=> $address,
            'address2'=> $address2,
            'city'=> $city,
            'postalCode'=> $zip_code,
            'country'=> $country,
            'phone'=> $phone,
        ),
        'customer'=> array(
            'firstName'=>  $first_name,
            'lastName'=> $last_name,
            'company'=> $company,
            'email'=> $email,
            'optin' => $optin,
        )
    );

    if(get_option('tr_touchpoint_web')) {
        // Enable the touchpoint
        $payload['touchpointType'] = 'web';
        $payload['touchpointId'] = get_option('tr_touchpoint_id');
        
        // Create the UI to host the offers
        $touchpoint_text = get_option('tr_touchpoint_text');
        $div_touchpoint = "<h3 align=\"center\">$touchpoint_text</h3><div id=\"tr_touchpoint_container\"></div>";
        print $div_touchpoint;
    }

    // Oqutput the full snippet onto the HTML
    print "<script> window._trx.push(" . json_encode($payload) . ")</script>";
} 


function tr_snippet_head() {
    $api_key = get_option( 'tr_api_key' );
    $country = get_option( 'tr_country_code' );
    print "
    <script>
        window._trx_debug = false;
        window._trx = window._trx || [];
        window._trx.push(
            {event: 'setAccount', account: '$api_key', country: '$country'},
            {event: 'setConfig', config: {
                    platform: {
                        'name': 'WooCommerce',
                        'version': '" . tr_get_wc_version() . "',
                        'integrationVersion': '" . TR_VERSION . "'
                    }
                }
            }
        );
    </script>
    <script src=\"//static.transactionale.com/trx/v2/trx.js\" async=\"true\"></script>
    ";
}

function tr_check_optin($checkout)
{
    // Get the optin value stored in the user profile
    $optin_array = get_user_meta(get_current_user_id(), '_trx_optin');
    if (count($optin_array)) {
        $optin = $optin_array[0];
    } else {
        $optin = 0;
    }

    //terms and condition url
    $page_id_terms = get_option('woocommerce_terms_page_id');
    $url_terms = get_permalink($page_id_terms);

    woocommerce_form_field('_trx_optin', array(
        'type' => 'checkbox',
        'class' => array(
            'my-field-class form-row-wide'
        ) ,
        'label' => __('Desidero ricevere offerte ed accetto <a href=' . $url_terms . ' target=\'_blank\'>termini e condizioni</a>') ,
        'placeholder' => __('Guidence') ,
    ) , $optin);

}
 

function tr_save_optin() {
    $user_id = get_current_user_id();
    
    update_user_meta( $user_id, '_trx_optin', intval(esc_attr($_POST['_trx_optin'])));
}

/**
 * Checks that WooCommerce is v3
 * @return boolean
 */
function tr_wc_is_v3() {
    $wc_version = tr_get_wc_version();
    if (!$wc_version) return false;

    return intval(explode('.', $wc_version)[0]) == 3;
}

function tr_get_wc_version() {
    if ( ! function_exists( 'get_plugins' ) )
        require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
    $plugin_folder = get_plugins( '/' . 'woocommerce' );
    $plugin_file = 'woocommerce.php';
    if ( isset( $plugin_folder[$plugin_file]['Version'] ) ) {
        return $plugin_folder[$plugin_file]['Version'];
    } else {
        return NULL;
    }
}